import events from "node:events";
import fs from "node:fs";
import path from "node:path";
import {fileURLToPath} from "node:url";
import readline from 'node:readline';

export const channel = new events.EventEmitter();

// (function Input(information) {
//     console.info(`${information}`);
//     const __dirname = path.dirname(fileURLToPath(import.meta.url));
//     const input_stream: fs.ReadStream = fs.createReadStream(path.resolve(__dirname, '..') + "/index.html", 'utf8');
//     input_stream.on('error', (error) => console.info(`error: ${error.message}`));
//     input_stream.on('data', (html) => channel.emit('html', html));
// })("'Events' app. started...");

(function Keyboard(information) {
    console.info(`${information}`);

    const output_stream = fs.createWriteStream(
        path.resolve(path.dirname(fileURLToPath(import.meta.url)), '..') + "/Keyboard.txt");
    output_stream.on('error', (error) => console.info(`error: ${error.message}`));

    const input_stream = readline.createInterface({ // 'import readline from 'node:readline';'
        input: process.stdin,
        output: process.stdout,
        prompt: "Enter a sentence: "
    });
    input_stream.prompt();
    input_stream.on('line', (line) => {
        switch (line.trim()) {
            case 'exit':
                input_stream.close();
                break;
            default:
                output_stream.write(line + '\n');
                input_stream.prompt(); // Next sentence...
        }
    }).on('close', () => {
        output_stream.end();
        output_stream.on('finish', () => console.info("Sentences have been written to 'Keyboard.txt'..."));
        // Program stop (without error) is queued:
        setTimeout(() => process.exit(0));
    });
})("'Keyboard' app. started...");

